#!/usr/bin/php
<?php

const paw_kassa_VAT0 = '1104';  // НДС 0%
const paw_kassa_VAT10 = '1103';  // НДС 10%
const paw_kassa_VAT18 = '1102';  // НДС 18%
const paw_kassa_VATNOVAT = '1105';  // НДС не облагается
const paw_kassa_VATWR10 = '1107';  // НДС с рассч. ставкой 10%
const paw_kassa_VATWR18 = '1106';  // НДС с рассч. ставкой 18%

function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
							  $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null, $kassa_customer = null, $kassa_delivery = null)
{
	if ($success === true)
		$resultCode = '200';
	elseif ($repeatRequest === true)
		$resultCode = '402';
	else
		$resultCode = '500';
	$mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
	$response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
	$response .= "<MNT_RESPONSE>\n";
	$response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
	$response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
	$response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
	$response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
	if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
	{
		$response .= "<MNT_ATTRIBUTES>\n";
		foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
			if (!empty($v))
				$response .= "<ATTRIBUTE><KEY>{$k}</KEY><VALUE>{$v}</VALUE></ATTRIBUTE>\n";
		$response .= "</MNT_ATTRIBUTES>\n";
	}
	$response .= "</MNT_RESPONSE>\n";
	if ($echo === true)
	{
		header("Content-type: application/xml");
		echo $response;
	}
	else
		return $response;
	if ($die === true)
		die;
	return '';
}

set_include_path(get_include_path() . PATH_SEPARATOR . "/usr/local/mgr5/include/php");
define('__MODULE__', "pmpayanywaypayurl");

require_once 'bill_util.php';

echo "Content-Type: text/xml\n\n";

function response($success, $MNT_ID = '', $MNT_TRANSACTION_ID = '', $MNT_SECRET = '')
{
	$MNT_RESULT_CODE = ($success ? '200' : '500');
	$MNT_SIGNATURE = md5($MNT_RESULT_CODE . $MNT_ID . $MNT_TRANSACTION_ID . $MNT_SECRET);
	echo(simplexml_load_string
	(
		"<?xml version=\"1.0\" encoding=\"UTF-8\"?>" .
		"<MNT_RESPONSE>\n" .
		"<MNT_ID>{$MNT_ID}</MNT_ID>\n" .
		"<MNT_TRANSACTION_ID>{$MNT_TRANSACTION_ID}</MNT_TRANSACTION_ID>\n" .
		"<MNT_RESULT_CODE>{$MNT_RESULT_CODE}</MNT_RESULT_CODE>\n" .
		"<MNT_SIGNATURE>{$MNT_SIGNATURE}</MNT_SIGNATURE>\n" .
		"</MNT_RESPONSE>"
	)->asXML());
}

$param = CgiInput(true);

$requiredParams = array(
	'MNT_ID',
	'MNT_TRANSACTION_ID',
	'MNT_OPERATION_ID',
	'MNT_AMOUNT',
	'MNT_CURRENCY_CODE',
	'MNT_TEST_MODE',
	'MNT_SIGNATURE'
);
$requiredParamsFail = false;
foreach ($requiredParams as $rP)
	if (!isset($param[$rP]))
		$requiredParamsFail = true;
if ($requiredParamsFail === false)
{
	$info = LocalQuery("payment.info", array('elid' => $param['MNT_TRANSACTION_ID']));
	if (!empty($info))
	{
		$MNT_ID = $info->payment->paymethod[1]->MNT_ID;
		$MNT_TRANSACTION_ID = $info->payment->id;
		$MNT_AMOUNT = $info->payment->paymethodamount;
		$MNT_CURRENCY_CODE = $info->payment->currency[1]->iso;
		$MNT_TEST_MODE = $info->payment->paymethod[1]->MNT_TEST_MODE == 'on' ? '1' : '0';
		$MNT_OPERATION_ID = $param['MNT_OPERATION_ID'];
		$MNT_SECRET = $info->payment->paymethod[1]->MNT_SECRET;
		$MNT_KASSA = $info->payment->paymethod[1]->MNT_KASSA;

		$MNT_SIGNATURE = md5($MNT_ID . $MNT_TRANSACTION_ID . $MNT_OPERATION_ID . $MNT_AMOUNT . $MNT_CURRENCY_CODE . $MNT_TEST_MODE . $MNT_SECRET);

		if ($MNT_SIGNATURE === $param['MNT_SIGNATURE'])
		{
			$result = LocalQuery("payment.setpaid",
				array(
					'elid' => $param['MNT_TRANSACTION_ID'],
					'info' => 'PAID (ОПЛАЧЕНО): ' . $param['MNT_AMOUNT'] . ' ' . $param['MNT_CURRENCY_CODE'],
					'externalid' => $param['MNT_OPERATION_ID']
				));

			if (!empty($result) && property_exists($result, 'ok'))
			{
				if ($MNT_KASSA == 'on')
				{
					$inventoryPositions = array();
					foreach ($info->payment->items->item as $item)
					{
						$vatTag = paw_kassa_VATNOVAT;
						$taxamount = round(floatval($item->taxamount)*100);
						$notaxamount = round(floatval($item->notaxamount)*100);
						$amount = round(floatval($item->amount)*100);
						if (round($item->taxrate) == 10 && ($taxamount + $notaxamount) == $amount)
							$vatTag = paw_kassa_VATWR10;
						if (round($item->taxrate) == 10 && ($taxamount + $notaxamount) != $amount)
							$vatTag = paw_kassa_VAT10;
						if (round($item->taxrate) == 18 && ($taxamount + $notaxamount) == $amount)
							$vatTag = paw_kassa_VATWR18;
						if (round($item->taxrate) == 18 && ($taxamount + $notaxamount) != $amount)
							$vatTag = paw_kassa_VAT18;
						$inventoryPositions[] = array(
							'name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars(strval($item->name)))),
							'price' => strval($item->amount),
							'quantity' => '1',
							'vatTag' => $vatTag
						);
					}
					$kassa_inventory = json_encode($inventoryPositions);
					$response = monetaPayURLResponse($MNT_ID, $MNT_TRANSACTION_ID, $MNT_SECRET, true, false, false, false, $kassa_inventory, $clientEmail);
					echo $response;
					die;
				}
				response(true, $param['MNT_ID'], $param['MNT_TRANSACTION_ID'], $info->payment->paymethod[1]->MNT_SECRET);
				exit;
			}
		}
	}
}
response(false)

?>